3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
28 # Specify the device path to the DVD drive
31 # Specify the path to the log directory
32 logdir=/var/log/ripdvd
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
51 # 2-channel AVI encoding audio bit rate
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default.
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 # Otherwise, you will need to rerun the script providing the feature title with the -t option.
63 trust_feature_title_autodetect_when_uncertain=0
65 ###############################################
66 # Command line processing
73 typeset -i keep_intermediate_files=0
74 typeset -i make_final_dest_vob=0
75 typeset -i make_final_dest_iso=0
76 typeset -i make_final_dest_folder=0
77 typeset -i make_final_dest_avi=0
79 typeset -i show_usage=0
80 typeset -i mirror_mode=0
81 typeset -i target_bitrate=0
82 typeset -i target_size=0
83 typeset -i audio_2ch=0
84 typeset -i invalid_feature_title=0
85 typeset -i feature_title_override=0
86 typeset -i mplayer_dumpstream_incompatibility=0
88 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
93 (b) target_bitrate=$OPTARG;;
94 (s) target_size=$OPTARG;;
96 (v) make_final_dest_vob=1;;
97 (i) make_final_dest_iso=1;;
98 (f) make_final_dest_folder=1;;
99 (x) make_final_dest_avi=1;;
101 (k) keep_intermediate_files=1;;
102 (t) feature_title_override=$OPTARG;;
105 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
106 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
113 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
114 echo >&2 "Revision $REV"
116 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
117 echo >&2 " -n <dvdname> Specify what the name of the DVD is to process from $tmpdir"
118 echo >&2 " If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
119 echo >&2 " If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
120 echo >&2 " This is optional. If not specified, the dvd will be pulled from $dev"
121 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
122 echo >&2 " The default operation is non-mirror mode where only the main"
123 echo >&2 " feature title will be ripped."
124 echo >&2 " -v Make the final image a DVD VOB file"
125 echo >&2 " -i Make the final image a DVD ISO file"
126 echo >&2 " -f Make the final image a DVD folder"
127 echo >&2 " -x Make the final image an AVI (XVID) file"
128 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
129 echo >&2 " -s <size> Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
130 echo >&2 " -b <bitrate> Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"
131 echo >&2 " -2 Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
132 echo >&2 " -k Keep the intermediate files (good for debugging)"
133 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
134 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
135 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
136 echo >&2 " -w Set the sh Execute/Verbose flag"
141 if (($errors)) || (($show_usage))
146 # Sanity Check - Command Line Options
147 if [ "$dest" == "" ]; then
148 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
152 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
153 echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
157 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
158 echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
162 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
163 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
164 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
168 if [ $mirror_mode -eq 1 ]; then
169 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
170 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
171 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
176 # Sanity Check - Key executables
177 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
178 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
179 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
180 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
181 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
182 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
183 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
184 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
186 ###############################################
189 if [ -z "$dvdname" ]; then
190 # make sure the DVD device is accessible
191 volname $dev > /dev/null 2>&1
193 echo "-E- Can't access the DVD device $dev"
196 # now capture the volume name from the device
197 dvdname=`volname $dev | awk '{ print $1 }'`
200 # check to see if dvdname is a full path to a real directory
201 # if it is, set dvdname and dvdpath appropriately
202 if [ -d "$dvdname" ]; then
204 dvdname=`basename "$dvdname"`
205 if [ -z "$dvdname" ]; then
206 echo "-E- Unable to extract dvdname from path: $dvdpath"
209 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
210 echo "-E- You must supply a full path to a valid DVD folder with this option"
214 # check to see if dvdname is a full path to an MPG2 (VOB) file
215 # if it is, set dvdname and vobfile appropriately
216 if [ -f "$dvdname" ]; then
218 dvdname=`basename "$dvdname"`
219 file "$vobfile" | grep -q "MPEG"
221 # It is a valid MPEG2 file, now strip the extension off our dvdname
222 dvdname=${dvdname%.[^.]*}
224 echo "-E- Unsupported file type: $vobfile"
231 # Make sure we have a non-empty dvdname
232 if [ -z "$dvdname" ]; then
233 echo "-E- unable to determine dvdname"
237 # make sure our vobfile value is set
238 if [ -z "$vobfile" ]; then
239 vobfile="$dest/$dvdname.VOB"
242 # set up some variables to hold various logfiles
243 logfile="$logdir/$dvdname.log"
244 passlogfile="$tmpdir/divx2pass.log"
245 ddrescuelog=`tempfile`
246 dvdauthorlog=`tempfile`
250 # create the tmpdir if it doesn't already exist
251 if [ ! -d "$tmpdir" ]; then
254 echo "-E- Unable to create the tmpdir: $tmpdir"
259 # create the logdir if it doesn't already exist
260 if [ ! -d "$logdir" ]; then
263 echo "-E- Unable to create the logdir: $logdir"
268 ###############################################
271 if [ $keep_intermediate_files -eq 0 ]; then
272 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
273 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
274 [[ -e "$encodelog" ]] && rm -f "$encodelog"
275 [[ -e "$dumplog" ]] && rm -f "$dumplog"
277 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
278 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
279 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
280 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
286 if [[ -z "$1" ]]; then
287 msg="-E- control-c killed us"
291 echo -e 2>&1 "$msg" | tee -a "$logfile"
292 if [[ -n "$mailto" ]]; then
293 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
298 # Call our cleanup functions on INT and EXIT signals
299 trap fatal_and_exit INT
302 ###############################################
303 # processing functions
304 function make_dvd_iso_image {
308 # check to see if we have a dvdpath to rip from instead of $dev
309 if [ -z "$dvdpath" ]; then
310 # load the CSS codes in the DVD drive
311 lsdvd $dev >> "$logfile"
313 fatal_and_exit "-E- lsdvd $dev failed"
316 # read the DVD, ignoring/skipping CRC errors
317 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
319 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
321 cat "$ddrescuelog" >> "$logfile"
323 # rip from a path instead
324 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
328 function make_dvd_iso_image_from_folder {
334 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
336 # make an iso image out of our directory
337 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
338 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
340 # make sure we were able to create the iso image from the folder given to us
341 if [ ! -s "$tmpdir/$dvdname.iso" ] && [ $handle_error -eq 1 ]; then
342 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
343 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
344 # get the feature title from the DVD folder
345 get_feature_title "$dvdpath"
346 # create our main VOB file from the ISO
347 create_main_vob_with_mplayer "$dvdpath"
351 function make_dvdbackup_folder_image {
352 # extract the feature title from the DVD image
353 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
354 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
355 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
357 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
361 function make_dvdauthor_folder_image {
362 # create a new DVD video of the feature title
363 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
364 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
365 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
366 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
368 # There is a chance that dvdauthor won't like some of the VOBs.
369 # We can't tell ahead of time which ones it will choke on.
370 # So, we need to run it over and over again until it can process
371 # all the VOBs. If it can't handle one of them, run it through
372 # mencoder to fix it and try again. These errors are typically
373 # present due to the copy protection that ddrescue removed.
374 grep -q "SCR moves" $dvdauthorlog
375 while [ $? == 0 ]; do
376 # fix bad vobs that get the "SCR moves backwards" error:
377 # STAT: Processing VTS_01_0.VOB...
378 # ERR: SCR moves backwards, remultiplex input.
379 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
380 if [[ ! -f "$badvob" ]]; then
381 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
383 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
384 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
385 mv -f $badvob.fixed $badvob
386 echo "-> Creating DVD video $dest/$dvdname"
387 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
388 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
389 grep -q "SCR moves" $dvdauthorlog
393 function get_feature_title {
395 # if a feature title was given on the command line, use it
396 if [ $feature_title_override -ne 0 ]; then
397 feature_title=$feature_title_override
400 # otherwise, use lsdvd to figure it out
401 if [ $ripdvd -eq 1 ]; then
402 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
404 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
408 function create_main_vob_with_cat {
409 # cd to the feature title DVD folder
410 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
412 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
415 # concatenate all the VOBs together into 1 giant VOB
416 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
417 cat $vobs > "$tmpdir/$dvdname.VOB"
419 # cd back to the dir we started from
420 popd > /dev/null 2>&1
423 function create_main_vob_with_mplayer {
425 # argument processing
429 # make sure we have a valid feature title
430 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
431 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
434 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
435 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
436 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
437 msg="$msg We also detected another condition that requires us to use dumpstream. "
438 msg="$msg\n Unable to rip this DVD in the mode you requested."
439 fatal_and_exit "$msg"
442 # use mplayer to create the main VOB file
443 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
444 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
445 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
447 cat $dumplog | grep -v "^A:" >> "$logfile"
448 fatal_and_exit "-E- Mplayer Failed"
450 cat $dumplog | grep -v "^A:" >> "$logfile"
451 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
454 function get_audio_id_from_iso {
455 # Adjust our audio ID to find the english audio stream
456 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
459 mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
460 grep -q "aid: $aid" $aidcheck
461 while [ $? == 1 ] && [ $aid -lt 159 ]; do
463 grep -q "aid: $aid" $aidcheck
465 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
466 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
467 # mencoder default DVD audio track language selection (english)
468 lang_opts="-aid $aid -alang en"
471 function get_crop_from_iso {
473 echo "-> Detecting black frame border crop value from ISO file"
474 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
475 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
476 [[ -e "md5sums" ]] && rm -f "md5sums"
477 CROP=`cat $dumplog | grep CROP | tail -1`
478 echo " Found crop value of $CROP" >> "$logfile"
482 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
483 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
484 if [ -z "$CROP" ]; then
485 fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
487 if [ $CROPCHECK -lt 0 ]; then
492 echo " Setting mencoder crop filter to: $CROP"
495 function get_audio_id_from_vob {
496 # Adjust our audio ID to find the english audio stream
497 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
500 mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
501 grep -q "Found audio stream: $aid" $aidcheck
502 while [ $? == 1 ] && [ $aid -lt 159 ]; do
504 grep -q "Found audio stream: $aid" $aidcheck
506 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
507 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
508 # mencoder default DVD audio track language selection (english)
509 lang_opts="-aid $aid -alang en"
512 function check_vob_for_corrupted_start {
513 # check to see if the beginning of the DVD has a form of copy protection
514 # where they have deliberately broken the first X number of frames of the DVD.
515 # If we don't skip these, our resulting VOB file will not play.
516 badvobcheck=`tempfile`
519 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
521 fatal_and_exit "-E- Mencoder Failed"
523 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
524 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
525 (( skip = skip + 5 ))
526 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
527 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
529 fatal_and_exit "-E- Mencoder Failed"
531 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
533 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
535 # cat the giant VOB into mencoder to create a playable VOB file
536 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
538 fatal_and_exit "-E- Mencoder Failed"
542 function check_vob_for_completeness {
543 # check to make sure we got out a complete VOB.
544 # there is another kind of copy protection where the VOB's may
545 # have "MPG EOF" frames in the middle of the stream.
546 # this causes mencoder to not process the entire VOB, and exit without any errors.
547 # detect this by seeing how much smaller the dst vob is from the src vob.
548 MAX_FILESIZE_DELTA_PERCENT=70
549 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
550 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
551 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
552 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
553 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
554 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
555 create_main_vob_with_mplayer "$isofile"
556 [[ -e "$dumplog" ]] && rm -f $dumplog
557 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
558 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
559 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
560 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
565 function check_vob_for_too_many_video_packets {
566 # If our earlier algorithm to work around this failed, throw an error.
567 # check to see if this DVD has a protection scheme we don't know how to work around
568 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
569 # for some reason, the video is black, while the audio rolls, then the video finally comes
570 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
571 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
572 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
573 grep -q "Too many video packets in the buffer:" "$logfile"
575 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
576 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
577 create_main_vob_with_mplayer "$isofile"
578 grep -q "Too many video packets in the buffer:" $dumplog
580 [[ -e "$dumplog" ]] && rm -f $dumplog
581 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
583 [[ -e "$dumplog" ]] && rm -f $dumplog
587 function check_vob_for_a52_crc_errors {
588 # Let's see if we can playback our newly created VOB file without any errors.
589 # if there are issues, let's detect them now, and try to recreate the VOB
590 # there are some forms of copy protection that have missed above, that evidence
591 # themselves when we try to playback the VOB file. This was added to deal with
592 # the "a52: CRC check failed" copy protection scheme.
595 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
596 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
597 cat $dumplog | grep -v "^A:" >> "$logfile"
598 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
599 if [ $errors -gt $MAX_ERRORS ]; then
600 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
601 create_main_vob_with_mplayer "$isofile"
602 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
603 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
605 cat $dumplog | grep -v "^A:" >> "$logfile"
606 fatal_and_exit "-E- Mplayer Failed"
608 cat $dumplog | grep -v "^A:" >> "$logfile"
609 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
610 if [ $errors -gt $MAX_ERRORS ]; then
611 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
614 [[ -e "$dumplog" ]] && rm -f $dumplog
617 function calculate_bitrate_from_target_size {
618 # determine what our bitrate needs to be if a target size was specified instead
619 if [ $target_size -ne 0 ]; then
620 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
621 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
622 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
626 function create_dvdauthor_dvd_xml_file {
627 # make a dvdauthor xml menu file to create a valid DVD video from
628 # this script does a good job, but we'll still need to clean it up a bit after it runs
629 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
630 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
632 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
635 # replace the first line of the xml file to remove the bad dest path
636 awk -v line=1 -v new_content="<dvdauthor>" '{
642 }' dvd.xml > dvd.xml.new
643 mv -f dvd.xml.new dvd.xml
645 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
648 # remove the "<video " property line from the xml file
649 cat dvd.xml | grep -v "<video" > dvd.xml.new
650 mv -f dvd.xml.new dvd.xml
652 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
655 # remove the extra <pgc>..</pgc> pairs
656 cat dvd.xml | awk 'BEGIN {x=1}
658 if ($0~"</pgc>") {x=0}
660 if ($0~"<pgc>") {x=1}
662 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
663 mv -f dvd.xml.new dvd.xml
665 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
668 # remove the VTS_*_0.VOB file as this is just the main menu video clip
669 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
670 mv -f dvd.xml.new dvd.xml
672 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
676 function check_for_mplayer_dumpstream_incompatibility {
678 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
680 if [ ! -e "$vobfile" ]; then
681 # mplayer dumpstream does not work on DVDs that obscure the feature title.
682 # A DVD that has 99 titles, where the longest title isn't the main feature
683 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
684 # out what the feature title is. This script will run through that flow if we
685 # set use_mplayer_dumpstream to 0. Check for this here.
686 if [ $ripdvd -eq 1 ]; then
687 lsdvd $dev | grep -q "Title: 99"
689 lsdvd "$isofile" | grep -q "Title: 99"
691 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
692 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
693 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
694 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
695 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
696 invalid_feature_title=1
698 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
699 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
700 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
701 use_mplayer_dumpstream=0
702 invalid_feature_title=1
708 # There is another form of protection that causes the mplayer dumpstream to fail.
709 # This can be detected by telling mplayer to parse the VOB file by copying its audio
710 # video streams to a dummy output file (/dev/null). Do that here to check for that
711 # problem before continuing.
712 if [ -e "$vobfile" ]; then
713 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
714 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
715 grep -q "Too many audio packets in the buffer" $dumplog
717 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
718 use_mplayer_dumpstream=0
719 mplayer_dumpstream_incompatibility=1
721 [[ -e "$dumplog" ]] && rm -f $dumplog
725 function fill_mythvideo_metadata {
727 # This function must be passed the filename as an argument
728 # The filename must be a full path to the file
731 # Make sure the fill mythvideo metadata option has been set to 1
732 if [ $fill_mythvideo_metadata -eq 0 ]; then
733 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
737 # If the fill mythvideo metadata script is present, run it
738 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
739 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
740 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
741 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
743 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
744 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
748 function remove_intermediate_vob_file {
749 # remove the intermediate VOB file
750 if [ $keep_intermediate_files -eq 0 ]; then
751 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
753 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
757 function remove_intermediate_iso_file {
758 # remove the original DVD image
759 if [ $keep_intermediate_files -eq 0 ]; then
760 [[ -e "$isofile" ]] && rm "$isofile"
762 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
766 function remove_intermediate_dvdbackup_folder {
767 if [ $keep_intermediate_files -eq 0 ]; then
768 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
770 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
774 ###############################################
777 # Make a note of when this DVD rip started
779 echo -e "\n$date DVD rip started" >> "$logfile"
781 # Rip the DVD - Mirror Mode
782 if [ $mirror_mode -eq 1 ]; then
783 echo "-> Ripping DVD $dvdname to $dest"
785 # use ddrescue to make an ISO image of the disk
786 make_dvd_iso_image "$dest/$dvdname.iso"
788 # add this video data to the mythtv DB
789 fill_mythvideo_metadata "$dest/$dvdname.iso"
791 # eject the disk upon completion
795 echo "$date DVD rip completed" | tee -a "$logfile"
797 if [[ -n "$mailto" ]]; then
798 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
803 # Rip the DVD - Main Title Feature Only
804 if [ $mirror_mode -eq 0 ]; then
807 if [ $ripdvd -eq 1 ]; then
808 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
809 # use ddrescue to make an ISO image of the disk
810 make_dvd_iso_image "$tmpdir/$dvdname.iso"
813 # Rip image from DVD path
814 if [ -n "$dvdpath" ]; then
815 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
816 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
819 # make sure our isofile value is set
820 if [ -z "$isofile" ]; then
821 isofile="$tmpdir/$dvdname.iso"
824 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
826 if [ ! -e "$vobfile" ]; then
827 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
829 # get the feature title from the ISO
830 get_feature_title "$isofile"
832 # get the crop value from the ISO
835 # check for mplayer dumpstream incompatibilities
836 # if they exist, this method will set this mode to 0.
837 check_for_mplayer_dumpstream_incompatibility
839 if [ $use_mplayer_dumpstream -eq 1 ]; then
841 # get our audio id from the ISO file
842 get_audio_id_from_iso
844 # create our main VOB file from the ISO
845 create_main_vob_with_mplayer "$isofile"
847 # remove the intermediate VOB file
848 remove_intermediate_vob_file
850 # it's possible that our VOB is still corrupted in some manner
851 # check to make sure it is still a good VOB before continuing.
852 check_for_mplayer_dumpstream_incompatibility
856 if [ $use_mplayer_dumpstream -eq 0 ]; then
858 # use dvdbackup to make a DVD folder of the feature title
859 make_dvdbackup_folder_image
861 # create our main VOB file
862 create_main_vob_with_cat
864 # get our audio id from the VOB file
865 get_audio_id_from_vob
867 # check for corrupted VOB start
868 check_vob_for_corrupted_start
870 # check to make sure our VOB is complete
871 check_vob_for_completeness
873 # check to make sure our VOB doesn't have too many video packets
874 check_vob_for_too_many_video_packets
876 # check to make sure our VOB doesn't have a52 crc errors
877 check_vob_for_a52_crc_errors
879 # remove the intermediate VOB file
880 remove_intermediate_vob_file
884 # remove the intermediate ISO file
885 remove_intermediate_iso_file
888 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
892 if [ $make_final_dest_avi -eq 1 ]; then
893 echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
895 # determine what our bitrate needs to be if a target size was specified instead
896 calculate_bitrate_from_target_size
898 # There was a lot of experimentation to arrive at these values
899 # These seem to work OK for me. If they don't work for you, feel
900 # free to adjust/change as needed.
902 # Edit these as needed to suite your needs
903 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
904 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
905 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
906 mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
908 # There are a number of different ways to encode 6 channel audio.
909 # I've loaded 3 different ways into the mencoder_audioch_opts.
910 # It will cycle through them until it finds one that works.
911 # You can change the order to suit your needs.
912 if [ $audio_2ch -eq 0 ]; then
914 # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
915 #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
916 #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
918 # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
919 # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad
920 mencoder_audio_opts="-oac copy"
922 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
923 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
924 mencoder_audioch_opts[1]="-af channels=6"
925 mencoder_audioch_opts[2]=""
928 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
929 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
930 mencoder_audioch_opts[0]=""
933 # Do not edit this line. $mencoder_video_encoder_opts must be last
934 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
939 # Set some options based on which pass we are in
940 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
941 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
942 [ $PASS -eq 1 ] && output_file="/dev/null"
943 [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
945 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
946 for CH_OPTS in "${mencoder_audioch_opts[@]}";
948 echo -e " Encoding pass $PASS"
949 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
950 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
952 grep -q "\[channels\] Invalid" $encodelog
956 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
959 if [ $mencoder_retval != 0 ]; then
960 fatal_and_exit "-E- Unhandled mencoder error"
962 # Concatenate the encode log to our main log file, greping out unwanted lines
963 cat $encodelog | grep -v "Pos:" >> "$logfile"
966 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
967 [[ -e "$vobfile" ]] && rm -f "$vobfile";
968 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
970 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
971 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
975 # add this video data to the mythtv DB
976 [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi"
977 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
981 # use dvdbackup to make a DVD folder of the feature title
982 make_dvdbackup_folder_image
984 # cd to the feature title DVD folder
985 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
987 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
990 # create the dvd.xml file for dvdauthor
991 create_dvdauthor_dvd_xml_file
993 # make the final DVD folder image
994 make_dvdauthor_folder_image
996 # add this video data to the mythtv DB
997 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
999 # cd back to the dir we started from
1000 popd > /dev/null 2>&1
1002 if [ $make_final_dest_iso -eq 1 ]; then
1004 # make an iso image out of our directory
1005 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1007 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1008 if [ -s "$dest/$dvdname.iso" ]; then
1009 if [ $make_final_dest_folder -eq 0 ]; then
1010 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1011 # remove the folder of the DVD image now that we have a .iso version of it
1012 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1015 # we created an empty iso file, remove it
1016 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1017 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1018 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1021 # add this video data to the mythtv DB
1022 fill_mythvideo_metadata "$dest/$dvdname.iso"
1028 # remove the ddrescue DVD ISO image
1029 remove_intermediate_iso_file
1031 # remove the tmp dvdbackup folder of the DVD image
1032 remove_intermediate_dvdbackup_folder
1034 # eject the DVD disk upon completion
1035 [ $ripdvd -eq 1 ] && eject -T $dev
1038 echo "$date DVD rip completed" | tee -a "$logfile"
1040 if [[ -n "$mailto" ]]; then
1041 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"